@REM BEGIN COPYRIGHT
@REM *************************************************************************
@REM
@REM  Licensed Materials - Property of IBM
@REM  5725-C94, 5725-C95, 5725-C96
@REM  (C) Copyright IBM Corporation 2013, 2016. All Rights Reserved.
@REM  US Government Users Restricted Rights- Use, duplication or disclosure
@REM  restricted by GSA ADP Schedule Contract with IBM Corp.
@REM
@REM *************************************************************************
@REM END COPYRIGHT

@ECHO OFF
SETLOCAL

ECHO.
ECHO IBM Business Process Manager 8.5.7.201609 Upgrade
ECHO.

SET CUR_DIR=%cd%
cd /d "%~dp0.."
SET WAS_HOME=%cd%
cd /d %WAS_HOME%\bin

REM Must use Java 6 at the moment
CALL "%WAS_HOME%\bin\sdk\_setupsdk1.6_64.bat"
SET PATH=%JAVA_NATIVE_LIB_DIR%;%PATH%

:setupArguments
SET DBUPGRADE_RESOURCE_DIR=%WAS_HOME%\util\dbUpgrade\
SET RC=0
SET WAS_HOME_PROP=-Dwas.install.root="%WAS_HOME%"
SET APP_JAVA_POLICY=-Djava.security.policy="file:%DBUPGRADE_RESOURCE_DIR%java.policy"
SET NODE_NAME_PROP=
SET SERVER_NAME_PROP=
SET LOGGING_PROP=-Dcom.lombardisoftware.ant.JULDefaultLogger.level=DEBUG -Djava.util.logging.config.file="%DBUPGRADE_RESOURCE_DIR%logging.properties" -Dtw.log4j.init=false
SET LOGGING_FILTER_PROP=-Dcom.ibm.bpm.migration.logging.StringFilter.excludes=contains(db.password);equals(WSVR0072W);equals(WSVR0801I);equals(WKSP0500);equals(WSVR0643I);regexp(^Class.+loaded.from.ant.loader..parentFirst.);regexp(^Class.+loaded.from.parent.loader..parentFirst.);regexp(^Finding.class.+\..+\..+);regexp(^Loaded.from.+\.jar..+\.class$)
SET LOGGING_PROP=%LOGGING_PROP% %LOGGING_FILTER_PROP%
SET ANT_PROPS=-q -e -logger com.lombardisoftware.ant.JULDefaultLogger

SET FULL_COMMAND=%0
SET FULL_COMMAND=%FULL_COMMAND:"=%
SET UPGRADECOMMAND_PROP=-Dupgradecommand="%FULL_COMMAND% %*"
set COMMAND_NAME_PROPS=-Dmig.command.name=%~n0

IF "%1" == "" GOTO help

:processArguments
IF "%1" == "-?" GOTO help
IF "%1" == "-help" GOTO help

IF "%1"=="-propertiesFile" (
        IF "%2"== "" (
                GOTO NoValueSpecified
        ) ELSE (
                SET MIGRATION_PROPERTIES_FILE=-DpropertiesFile=%2%&SHIFT&SHIFT&GOTO processArguments
        )
)

IF "%1"=="-backupFolder" (
        IF "%2"== "" (
                GOTO NoValueSpecified
        ) ELSE (
                SET BACKUP_FOLDER_PROP=-DbackupFolder=%2%&SHIFT&SHIFT&GOTO processArguments
        )
)

IF "%1"=="-profileName" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SET PROFILE_NAME=-DprofileName=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-de" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SET DE_NAME=-DdeName=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-noPrompt" (
        SET NO_PROMPT_PROP=-DnoPrompt=true&SHIFT&GOTO processArguments
)

IF "%1"=="-generateSQLOnly" (
        SET GENERATE_SQL_ONLY=-DgenerateSQLOnly=true&SHIFT&GOTO processArguments
)

IF "%1"=="-omitSQLGeneration" (
        SET OMIT_SQL_GENERATION=-DomitSQLGeneration=true&SHIFT&GOTO processArguments
)

IF NOT "%1"=="" (
        ECHO Invalid parameter: %1%, please correct it and try again.
        GOTO help
)

SET WAS_EXT_DIRS=%JAVA_HOME%\lib;%WAS_HOME%\classes;%WAS_HOME%\lib;%WAS_HOME%\lib\ext

SET CLASSPATH=%DBUPGRADE_RESOURCE_DIR%
SET CLASSPATH=%CLASSPATH%;%DBUPGRADE_RESOURCE_DIR%lib\ant.jar
SET CLASSPATH=%CLASSPATH%;%DBUPGRADE_RESOURCE_DIR%lib\ant-launcher.jar
SET CLASSPATH=%CLASSPATH%;%DBUPGRADE_RESOURCE_DIR%lib\ant-nodeps.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\BPM\Lombardi\lib\ant-contrib.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\BPM\Lombardi\lib\twant.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\plugins\com.ibm.bpm.migration.logging.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\plugins\com.ibm.bpm.config.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\plugins\com.ibm.bpm.config.model.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\plugins\com.ibm.bpm.config.model.rest.service.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\plugins\com.ibm.bpm.config.model.federation.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\plugins\com.ibm.bpm.config.model.bspace.jar

SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ffdc.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.hpel.logging.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.admin.core.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.admin.services.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.bootstrap.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.emf.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.javaee.dd.common.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.javaee.dd.ejb.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.runtime.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.wccm.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.ws.wlm.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.wsfp.main.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/com.ibm.wsspi.extension.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/org.eclipse.core.runtime_.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/org.eclipse.equinox.common_.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/org.eclipse.equinox.registry.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/org.eclipse.osgi_.jar

SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/lib/bootstrap.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/lib/j2ee.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/org.eclipse.emf.ecore.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/org.eclipse.emf.common.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%/plugins/org.eclipse.emf.ecore.xmi.jar

@REM *************************************************************************
@REM
@REM Enabling custom password encryption
@REM
@REM If you enabled the custom password encryption to protect passwords
@REM that are contained in your WebSphere(R) Application Server configuration,
@REM uncomment the following properties.
@REM Replace "com.ibm.wsspi.security.crypto.CustomPasswordEncryptionImpl"
@REM with your custom password encryption class name.
@REM Replace "c:/WAS/classes/WASCustomPasswordEncryption.jar"
@REM with the full file path of your custom password encryption JAR file.
@REM
@REM *************************************************************************
@REM SET CLASSPATH=%CLASSPATH%;c:/WAS/classes/WASCustomPasswordEncryption.jar
@REM SET CUSTOMPWDPROPS=-Dcom.ibm.wsspi.security.crypto.customPasswordEncryptionClass=com.ibm.wsspi.security.crypto.CustomPasswordEncryptionImpl
@REM SET CUSTOMPWDPROPS=%CUSTOMPWDPROPS% -Dcom.ibm.wsspi.security.crypto.customPasswordEncryptionEnabled=true

"%JAVA_HOME%\bin\java" -Dfile.encoding=UTF-8 %CUSTOMPWDPROPS% -Xms512m -Xmx1536m -Dws.ext.dirs="%WAS_EXT_DIRS%" -cp "%CLASSPATH%" %WAS_HOME_PROP% %APP_JAVA_POLICY% %COMMAND_NAME_PROPS% %MIGRATION_PROPERTIES_FILE% %BACKUP_FOLDER_PROP% %NO_PROMPT_PROP% %PROFILE_NAME% %DE_NAME% %GENERATE_SQL_ONLY% %OMIT_SQL_GENERATION% %LOGGING_PROP% %UPGRADECOMMAND_PROP% org.apache.tools.ant.Main -buildfile "%DBUPGRADE_RESOURCE_DIR%upgrade.xml" %ANT_PROPS%
SET RC=%ERRORLEVEL%
GOTO end

:NoValueSpecified
ECHO No value specified for parameter %1
GOTO help

:help
ECHO.
ECHO Usage, you can run DBUpgrade.bat -? or -help to see this help message:
ECHO.
ECHO    DBUpgrade.bat [options...]
ECHO.
ECHO Options for Migration:
ECHO    -propertiesFile ^<migration_properties_file^>     Full path of migration properties file.
ECHO    -backupFolder ^<snapshot_folder^>     Directory of backup folder from source environment, only needed for migration from IBM BPM Advanced or WebSphere Process Server.
ECHO    -noPrompt     (optional)Set this parameter to make the tool work with no interaction. If you do not set this parameter, the tool will prompt you to confirm.
ECHO    -generateSQLOnly     (optional)Set this parameter to make the tool only generate upgrade SQL scripts without executing them.
ECHO    -omitSQLGeneration   (optional)Set this parameter to make the tool omit to generate upgrade SQL scripts step.
ECHO.
ECHO Options for Upgrade:
ECHO    -profileName ^<profile_name^> -de ^<de_name^>   For the upgrade path only. You can omit the '-de' parameter if there is only one deployment environment.
ECHO    -generateSQLOnly     (optional)Set this parameter to make the tool only generate upgrade SQL scripts without executing them.
ECHO    -omitSQLGeneration   (optional)Set this parameter to make the tool omit to generate upgrade SQL scripts step.
ECHO.
GOTO end

:end
ECHO.
EXIT /B %RC%
ENDLOCAL
