@REM 5724-J08, 5724-I63, 5724-H88, 5724-H89, 5655-N02, 5733-W70 (C) COPYRIGHT International Business Machines Corp. 2012
@REM All Rights Reserved * Licensed Materials - Property of IBM
@REM US Government Users Restricted Rights - Use, duplication or di`sclosure
@REM restricted by GSA ADP Schedule Contract with IBM Corp.
                               
@echo off

setlocal
SETLOCAL ENABLEEXTENSIONS

REM Detect how script was launched.  The INV_PAUSE_ON_CLOSE
REM variable is used to prevent a cmd window from closing when
REM launched from an explorer window
@echo %cmdcmdline% | findstr /R /C:"cmd.* /[cC] " > NUL
if %ERRORLEVEL% EQU 0 set INV_PAUSE_ON_CLOSE=1


if exist "%~dp0setupCmdLine.bat" CALL "%~dp0setupCmdLine.bat" %* 

set "MY_ISADC_HOME=%WAS_HOME%/BPM/isadc"

if exist "%JAVA_HOME%\bin\java.exe" (
   set JAVA_EXE="%JAVA_HOME%\bin\java"
) else (
   set JAVA_EXE="%JAVA_HOME%\jre\bin\java"
)

set CMD_NAME=%~nx0
set CMD_NAME_ONLY=%~n0
set PRODUCT_INVOKE=TRUE
set "CURRENT_DIR=%~dp0%"

FOR %%I IN ("%CURRENT_DIR%") DO SET CURRENT_DIR=%%~sI

:: end 


SET COLLECTORTYPE=
SET "UPLOAD=FALSE"
SET PMRNUMBER=
SET "CONFIG=FALSE"
SET OUTPUTDIR=

:CHECKSWITCH

if /I "%1" == "-help"  goto displayHelp
if /I "%1" == "-Help"  goto displayHelp
if /I "%1" == "/h" goto displayHelp
if /I "%1" == "-h" goto displayHelp
if /I "%1." == "-collectorType." goto setCollectorType
if /I "%1." == "-type." goto setCollectorType
if /I "%1." == "-pmrNumber." goto setPMRNumber
if /I "%1." == "-PMR." goto setPMRNumber
if /I "%1." == "-pmr." goto setPMRNumber
if /I "%1." == "-config." goto setConfig
if /I "%1." == "-uploadToIBM." goto setUpload
if /I "%1." == "-outputDirectory." goto setOutputDirectory
if /I "%1." == "-user." goto setUser
if /I "%1." == "-password." goto setPassword
if /I "%1." == "-count." goto setCount
if /I "%1." == "-interval." goto setInterval
if /I "%1." == "-server." goto setServer
if /I "%1." == "-dumptype." goto setDumptype
if /I "%1." == "-soapport." goto setSoapport
if not "%1" == "" (
	echo Wrong Paramater: %1
	goto displayHelp
)
goto processParameters 

:setCollectorType
 
SET COLLECTORTYPE=%~2
set isCollectorTypeSet=TRUE
REM echo COLLECTORTYPE is %COLLECTORTYPE%

if /I "%COLLECTORTYPE%" == "General" goto jumpOut 
if /I "%COLLECTORTYPE%" == "Install" goto jumpOut
if /I "%COLLECTORTYPE%" == "Dump" goto jumpOut 
if "%COLLECTORTYPE%" NEQ "General" (
echo "ERROR: unknown value for the parameter -type or -collectorType"
goto displayHelp
)

:jumpOut
:: end jumpOut
SHIFT 
SHIFT
rem goto parsePMR
goto :CHECKSWITCH
:: end setCollectorType


:setPMRNumber

SET PMRNUMBER=%~2
rem FOR /F "delims=,. tokens=1-3" %%f IN ("%PMRNUMBER%") DO (
rem 	set PMRNUMBER=%%f.%%g.%%h
rem )
REM echo PMRNUMBER is %PMRNUMBER%
SET isPmrNumberSet=TRUE
SHIFT 
SHIFT
goto parsePMR
goto :CHECKSWITCH
:: end setPMRnumber

:setConfig 
if /I "%2" == "yes" goto :validConfig
if /I "%2" == "y" goto :validConfig
if /I "%2" == "no" goto :validConfig
if /I "%2" == "n" goto :validConfig
echo CONFIG must be yes or no
goto displayHelp
:: end setConfig

:validConfig
set CONFIG=%~2
REM echo CONFIG is %CONFIG%
set isConfigSet=TRUE
SHIFT 
SHIFT
goto :CHECKSWITCH
:: end validConfig

:setUpload
if /I "%2" == "yes" goto :validUpload
if /I "%2" == "y" goto :validUpload
if /I "%2" == "no" goto :validUpload
if /I "%2" == "n" goto :validUpload
echo uploadToIBM must be yes or no
goto displayHelp
:: end setUpload

:validUpload
set UPLOAD=%~2
REM echo UPLOAD IS %UPLOAD% 
set isUploadSet=TRUE
SHIFT 
SHIFT
goto :CHECKSWITCH
:: end validUpload

: setOutputDirectory

set OUTPUTDIR=%~2
set isOutputDirectorySet=TRUE
SHIFT
SHIFT
goto :CHECKSWITCH

:: end setOutputDirectory

: setUser

set USER=%~2
set isUserSet=TRUE
SHIFT
SHIFT
goto :CHECKSWITCH

:: end setUser

: setPassword

set PASSWORD=%~2
set isPasswordSet=TRUE
SHIFT
SHIFT
goto :CHECKSWITCH

:: end setPassword

: setCount
if %~2 gtr 0x3FFFFFFF  goto countInvalid
if 1 gtr %~2  goto countInvalid
set COUNT=%~2
set isCountSet=TRUE
SHIFT
SHIFT
goto :CHECKSWITCH
:: end setCount

: countInvalid
echo parameter count must be a positive integer
goto displayHelp
:: countInvalid


: setInterval
if %~2 gtr 0x3FFFFFFF goto intervalInvalid
if 0 gtr %~2  goto intervalInvalid
set INTERVAL=%~2
set isIntervalSet=TRUE
SHIFT
SHIFT
goto :CHECKSWITCH

:: end setInterval

: intervalInvalid
echo parameter interval must be a nonnegative integer
goto displayHelp
:: end intervalInvalid

: setServer

set SERVER=%~2
set isServerSet=TRUE
SHIFT
SHIFT
goto :CHECKSWITCH

:: end setServer

: setDumptype

set DUMPTYPE=%~2
set isDumptypeSet=TRUE
if /I "%DUMPTYPE%" == "Thread" (
set DUMP_OPTION=dumpThreads
goto jumpOut
)
if /I "%DUMPTYPE%" == "Heap" (
set DUMP_OPTION=generateHeapDump
goto jumpOut
)
if /I "%DUMPTYPE%" == "System" (
set DUMP_OPTION=generateSystemDump
set JEXTRACT="%JAVA_HOME%\jre\bin\jextract.exe"
set "Temp_FILE=%MY_ISADC_HOME%\util\Temp.txt"
goto jumpOut
)

echo "ERROR: unknown value for the parameter -dumptype"
goto displayHelp

:: end setDumptype

: setSoapport

set SOAPPORT=%~2
set isSoapportSet=TRUE
SHIFT
SHIFT
goto :CHECKSWITCH

:: end setSoapport

:displayHelp

echo. 
echo Command invocation example
echo.
echo bpmdc.bat -type=General -PMR=(pmrNumber) -config=yes -uploadToIBM=yes -outputDirectory=(location of output directory) -user=(wsadmin username) -password=(wsadmin password) -count=(number of dumps) -interval=(number of seconds) -server=(name of server) -dumptype=Thread -soapport=8879
echo    where -type=General / Install / Dump   {Optional}  {Defaults to General} 
echo    -PMR in 11111.bbb.CCC format	{Optional}  {Defaults to none, No upload}
echo    -config option to collect the config directory {Optional}  {Defaults to No}
echo    -uploadToIBM to send the collected data with FTP option {Optional} {Defaults to No}
echo    -outputDirectory is the location where you want to create the output zip { Defaults to WAS_HOME/BPM/isadc folder } You should enclose the outputDirectory in double quotes if it has a blank character
echo    "-user and -password : the user name and password for running wsadmin.sh/bat"
echo    "-count and -interval {Optional} {Defaults to 1 for count, and 0 for interval} {if type=Dump specified, bpmdc should do this <count> times with a delay of <interval> in between}"
echo    "-server is the name of the server which you want to collect dumps for. If specified, you must run bpmdc in the <Profile_Home>/bin of the profile where the server was created. {Madatory if type=Dump specified}"
echo    -dumptype=Thread / Heap / System     {Optional}    {The Thread dump type should trigger a javacore or thread dump depending on OS, The Heap dump type should trigger a heapdump using the appropriate command depending on the OS. The System dump would only work on AIX,Linux or Windows. It should run jextract on the core file created.}
echo    -soapport is the port number of the SOAP connection of the wsadmin, if specifies -server, use the SOAP_CONNECTOR_ADDRESS of that server.
echo    -help to display help
echo. 		
echo If invoked without any option then the default options will be picked.
echo The Default options are 
echo -type=General -config=no -uploadToIBM=No {PMR not needed} -outputDirectory=(Full path to collection)

goto end 

rem exit
:: end displayHelp

:parsePMR

rem echo PMRNUMBER is %PMRNUMBER%
FOR /F "tokens=1,2,3 delims=.," %%A in ("%PMRNUMBER%") Do (
SET pmrNo=%%A 
SET BranchNum=%%B 
SET CountryCode=%%C
)
set firstLen=0
set secondLen=0
set thirdLen=0

:pmrLoop
if defined pmrNo (set pmrNo=%pmrNo:~1%&set /A firstLen += 1&goto pmrLoop)

:BranchLoop
if defined BranchNum (set BranchNum=%BranchNum:~1%&set /A secondLen += 1&goto BranchLoop)

:CountryCodeLoop
if defined CountryCode (set CountryCode=%CountryCode:~1%&set /A thirdLen += 1&goto CountryCodeLoop)

set "validPMR=true"
if "%firstLen%" NEQ "6" set "validPMR=false"
if "%secondLen%" NEQ "4" set "validPMR=false"
if "%thirdLen%" NEQ "3" set "validPMR=false"

if "%validPMR%" == "false" ( 
echo.
echo Wrong PMR number format - %PMRNUMBER%
echo PMR Format should be PPPPP.BBB.CCC
echo where PPPPP is PMR Number, BBB is the branch and CCC is the country code.
goto displayHelp
exit /b 0
)
goto :CHECKSWITCH

:: end parsePMR

: generateDump

set WSADMIN=%WAS_HOME%\bin\wsadmin.bat -conntype SOAP -port %SOAPPORT% -user %USER% -password %PASSWORD%
REM echo running wsadmin: %WSADMIN%
REM echo %COUNT%
REM echo %INTERVAL%
REM echo %DUMP_OPTION%
REM echo %SOAPPORT%
REM echo %SERVER%
if /I "%DUMPTYPE%" == "System" (
echo ### Begin generating system dump > "%Temp_FILE%"
)
echo Connecting to server %SERVER% at soap port %SOAPPORT% to run the server dumps...
setlocal EnableDelayedExpansion
FOR /L %%X in (1,1,%COUNT%) do (
CALL %WSADMIN% -f %MY_ISADC_HOME%/util/dump.jacl %SERVER% %DUMP_OPTION%

if "!ERRORLEVEL!" NEQ "0" (
echo Wsadmin throws out a error, please examine the exception message above and check your inputs.
rem goto :displayHelp
goto :end
)
TIMEOUT /T %INTERVAL%
)
setlocal DisableDelayedExpansion
if /I "%DUMPTYPE%" == "System" (
echo "Running jextract tool ( it could take a couple of minutes ) ..."
"%JAVA_HOME%\bin\java" -classpath "%MY_ISADC_HOME%/util/dcutil.jar" com.ibm.ws.bpm.isadc.main.SystemDumpCollectorMain "%JEXTRACT%" "%USER_INSTALL_ROOT%" "%Temp_FILE%"
DEL /Q/F "%Temp_FILE%"
echo "%Temp_FILE%"
)
goto writeToResponseFile

:: end generateDump

: processParameters
 
if NOT DEFINED isCollectorTypeSet set "COLLECTORTYPE=General"
 
if NOT DEFINED isConfigSet set "CONFIG=FALSE"

if NOT DEFINED isUploadSet set UPLOAD=FALSE
if NOT DEFINED isPmrNumberSet set UPLOAD=FALSE

if DEFINED isPmrNumberSet ( 
REM Check the PMR number format
set "toBeSentToEcurep=false"
 
if /I "%UPLOAD%" == "yes" set "toBeSentToEcurep=true"
if /I "%UPLOAD%" == "y" set "toBeSentToEcurep=true"
if "%UPLOAD%" == "Yes" set "toBeSentToEcurep=true"
) 

REM NOTE
REM We are doing everything in reference to USER_ISNTALL_ROOT-
REM Make sure we change this if we are to move ISA DC core to somewhere else
REM NOTE


FOR %%I IN ("%USER_INSTALL_ROOT%") DO SET USER_INSTALL_ROOT=%%~sI

set DATE_TIME=%DATE:/=-%_%TIME::=-%
set DATE_TIME=%DATE_TIME: =%

IF /I "%COLLECTORTYPE%" == "Dump" (
	if "%SERVER%" NEQ "" set "zipFileHasServer=true"
)
if DEFINED zipFileHasServer (
	if DEFINED isOutputDirectorySet (
		FOR %%I IN ("%OUTPUTDIR%") DO SET OUTPUTDIR=%%~sI
		IF NOT EXIST "%OUTPUTDIR%" (
			md "%OUTPUTDIR%"  2>&1 >NUL
		)
		set "FILENAME=%OUTPUTDIR%/%WAS_NODE%_%COLLECTORTYPE%_%SERVER%_%DATE_TIME%.zip"
		if DEFINED isPmrNumberSet set "FILENAME=%OUTPUTDIR%/%PMRNUMBER%.%WAS_NODE%_%COLLECTORTYPE%_%SERVER%_%DATE_TIME%.zip"
	 
		if "%toBeSentToEcurep%" == "true"  ( 
			set "FILENAME=%OUTPUTDIR%/%WAS_NODE%_%COLLECTORTYPE%_%SERVER%_%DATE_TIME%.zip"
			set "FILENAMETOECUREP=%OUTPUTDIR%/%PMRNUMBER%.%WAS_NODE%_%COLLECTORTYPE%_%SERVER%_%DATE_TIME%.zip"
		)
	) else (
		set "FILENAME=%MY_ISADC_HOME%/%WAS_NODE%_%COLLECTORTYPE%_%SERVER%_%DATE_TIME%.zip"
		if DEFINED isPmrNumberSet set "FILENAME=%MY_ISADC_HOME%/%PMRNUMBER%_%WAS_NODE%_%COLLECTORTYPE%_%SERVER%_%DATE_TIME%.zip"
	 
		if "%toBeSentToEcurep%" == "true" (
			set "FILENAME=%MY_ISADC_HOME%/%WAS_NODE%_%COLLECTORTYPE%_%SERVER%_%DATE_TIME%.zip"
			set "FILENAMETOECUREP=%MY_ISADC_HOME%/%PMRNUMBER%.%WAS_NODE%_%COLLECTORTYPE%_%SERVER%_%DATE_TIME%.zip"
		)
	)
) else (
	if DEFINED isOutputDirectorySet (
		FOR %%I IN ("%OUTPUTDIR%") DO SET OUTPUTDIR=%%~sI
		IF NOT EXIST "%OUTPUTDIR%" (
			md "%OUTPUTDIR%"  2>&1 >NUL
		)
		set "FILENAME=%OUTPUTDIR%/%WAS_NODE%_%COLLECTORTYPE%_%DATE_TIME%.zip"
		if DEFINED isPmrNumberSet set "FILENAME=%OUTPUTDIR%/%PMRNUMBER%.%WAS_NODE%_%COLLECTORTYPE%_%DATE_TIME%.zip"
	 
		if "%toBeSentToEcurep%" == "true"  ( 
			set "FILENAME=%OUTPUTDIR%/%WAS_NODE%_%COLLECTORTYPE%_%DATE_TIME%.zip"
			set "FILENAMETOECUREP=%OUTPUTDIR%/%PMRNUMBER%.%WAS_NODE%_%COLLECTORTYPE%_%DATE_TIME%.zip"
		)
	) else (
		set "FILENAME=%MY_ISADC_HOME%/%WAS_NODE%_%COLLECTORTYPE%_%DATE_TIME%.zip"
		if DEFINED isPmrNumberSet set "FILENAME=%MY_ISADC_HOME%/%PMRNUMBER%_%WAS_NODE%_%COLLECTORTYPE%_%DATE_TIME%.zip"
	 
		if "%toBeSentToEcurep%" == "true" (
			set "FILENAME=%MY_ISADC_HOME%/%WAS_NODE%_%COLLECTORTYPE%_%DATE_TIME%.zip"
			set "FILENAMETOECUREP=%MY_ISADC_HOME%/%PMRNUMBER%.%WAS_NODE%_%COLLECTORTYPE%_%DATE_TIME%.zip"
		)
	)
)


if /I "%COLLECTORTYPE%" == "Dump" (
	if NOT DEFINED isUserSet (
		echo "ERROR: -user must be specified when the collectorType is Dump"
		goto displayHelp
	)
	if NOT DEFINED isPasswordSet (
		echo "ERROR: -password must be specified when the collectorType is Dump"
		goto displayHelp
	)
	if NOT DEFINED isServerSet (
		echo "ERROR: -server must be specified when the collectorType is Dump"
		goto displayHelp
	)
	if NOT EXIST "%USER_INSTALL_ROOT%/logs/%SERVER%" (
		echo "ERROR: this script must be run in the <Profile_Home>/bin of the profile on which the server you specified was created"
		goto displayHelp
	)
	if NOT DEFINED isSoapportSet (
		echo "ERROR: -soapport must be specified when the collectorType is Dump"
		goto displayHelp
	)
	if NOT DEFINED isDumptypeSet SET DUMP_OPTION=dumpThreads
	if NOT DEFINED isCountSet set COUNT=1
	if NOT DEFINED isIntervalSet set INTERVAL=0

) else (
	if DEFINED isUserSet (
		echo "ERROR: -user should not be specified when the collectorType is not Dump"
		goto displayHelp
	)
	if DEFINED isPasswordSet (
		echo "ERROR: -password should not be specified when the collectorType is not Dump"
		goto displayHelp
	)
	if DEFINED isServerSet (
		echo "ERROR: -server should not be specified when the collectorType is not Dump"
		goto displayHelp
	)	
	if DEFINED isSoapportSet (
		echo "ERROR: -soapport should not be specified when the collectorType is not Dump"
		goto displayHelp
	)
	if DEFINED isDumptypeSet (
		echo "ERROR: -dumptype should not be specified when the collectorType is not Dump"
		goto displayHelp
	)
	if DEFINED isCountSet (
		echo "ERROR: -count should not be specified when the collectorType is not Dump"
		goto displayHelp
	)
	if DEFINED isIntervalSet (
		echo "ERROR: -interval should not be specified when the collectorType is not Dump"
		goto displayHelp
	)
)

: beginCollection

echo Running the Collector command with the following options
ECHO /-------------------------------------------------------------------------------
echo type=%COLLECTORTYPE%
if /I "%COLLECTORTYPE%" == "Dump" (
	echo dumptype=%DUMPTYPE%
	echo count=%COUNT%
	echo interval=%INTERVAL%
)
echo config=%CONFIG% 
echo uploadToIBM=%UPLOAD% 
echo PMR=%PMRNUMBER% 
echo outputDirectory=%OUTPUTDIR%
echo \-------------------------------------------------------------------------------
echo. 
echo The collection is beginning and could take a few minutes depending on the size.

if /I "%COLLECTORTYPE%" == "Dump" (
	goto generateDump
)


: writeToResponseFile
 
SET "RESP_FILE=%MY_ISADC_HOME%/util/ResponseFile.txt"
SET "PROP_FILE=%MY_ISADC_HOME%/util/properties.txt"


REM look into possibility of creating Datetime filename 
REM echo FILENAME is %FILENAME%

echo ### Begin Response File > "%RESP_FILE%"
echo ### Begin Properties File > "%PROP_FILE%"

echo 10.CollectionZipName=%FILENAME% >> "%RESP_FILE%"
echo 20.YesNo=1 >> "%RESP_FILE%"
if /I "%COLLECTORTYPE%" == "General" ( 
echo 30.CollectionOption=1 >> "%RESP_FILE%"
) 
if /I "%COLLECTORTYPE%" == "Install" (
echo 30.CollectionOption=2 >> "%RESP_FILE%"
) 
if /I "%COLLECTORTYPE%" == "Dump" (
echo 30.CollectionOption=3 >> "%RESP_FILE%"
) 


REM Properties file - populate 
REM echo config is %CONFIG%

if /I "%CONFIG%" == "yes" goto EditPropertiesFileForConfig 
if /I "%CONFIG%" == "y" goto EditPropertiesFileForConfig 
if "%CONFIG%" NEQ "yes" (
echo config=%CONFIG%>> "%PROP_FILE%"
goto jumpTo
)


:EditPropertiesFileForConfig
echo config=true>> "%PROP_FILE%"
:: end EditPropertiesFileForConfig

:jumpTo



if /I "%UPLOAD%" == "yes" goto EditResponseFileForUpload
if /I "%UPLOAD%" == "y" goto EditResponseFileForUpload
if "%UPLOAD%" NEQ "Yes" (
echo 40.SelectListOption=4 >> "%RESP_FILE%"
echo 50.OptionToCompleteInputDialog=1 >> "%RESP_FILE%"
)

goto InvokeCommand

:EditResponseFileForUpload
echo upload=%UPLOAD%>> "%PROP_FILE%"
echo pmr.number=%PMRNUMBER%>> "%PROP_FILE%"

echo 40.SelectListOption=2 >> "%RESP_FILE%"
echo 50.OptionToCompleteInputDialog=1 >> "%RESP_FILE%"
echo 60.MultipleChoiceInputRequest=1 >> "%RESP_FILE%"

:: end EditResponseFileForUpload


:InvokeCommand

FOR %%I IN ("%USER_INSTALL_ROOT%") DO SET USER_INSTALL_ROOT=%%~sI

CALL "%MY_ISADC_HOME%/isadc.bat" -silent "%MY_ISADC_HOME%/util/ResponseFile.txt" > "%MY_ISADC_HOME%/util/ResponseLog.txt" 

IF /I "%COLLECTORTYPE%" == "Dump" (
REM clean up the dump files
	IF /I "%DUMPTYPE%" == "Thread" (
		IF EXIST "%USER_INSTALL_ROOT%/javacore.*" (
			DEL /Q "%USER_INSTALL_ROOT%\javacore.*"
		)
	)
	IF /I "%DUMPTYPE%" == "Heap" (
		IF EXIST "%USER_INSTALL_ROOT%/heapdump.*" (
			DEL /Q "%USER_INSTALL_ROOT%\heapdump.*"
		)
	)
	IF /I "%DUMPTYPE%" == "System" (
		IF EXIST "%USER_INSTALL_ROOT%/core.*" (
			DEL /Q "%USER_INSTALL_ROOT%\core.*"
		)
	)
)

IF EXIST "%FILENAME%" (

	ECHO /-------------------------------------------------------------------------------
    ECHO ^| Your collection file is located at :
	ECHO ^| %FILENAME%
	ECHO \-------------------------------------------------------------------------------
	ECHO.
  	ECHO Collection is complete
  	exit /b 0
) ELSE (
	if "%toBeSentToEcurep%" == "true" (
		IF EXIST "%FILENAMETOECUREP%" (
		
			ECHO /-------------------------------------------------------------------------------
		    ECHO ^| Your collection file is located at :
			ECHO ^| %FILENAMETOECUREP%
			ECHO \-------------------------------------------------------------------------------
			ECHO.
		  	ECHO Collection is complete
		  	exit /b 0
	) else ( 
		ECHO Collection failed.  Please see logs.
		exit /b 1
	)
)
	
 
)


: end
if defined INV_PAUSE_ON_CLOSE pause 
:: end END
endlocal